import usb._objfinalizer as _objfinalizer

class IBackend(_objfinalizer.AutoFinalizedObject):
    def enumerate_devices(self) -> None: ...
    def get_parent(self, dev) -> None: ...
    def get_device_descriptor(self, dev) -> None: ...
    def get_configuration_descriptor(self, dev, config) -> None: ...
    def get_interface_descriptor(self, dev, intf, alt, config) -> None: ...
    def get_endpoint_descriptor(self, dev, ep, intf, alt, config) -> None: ...
    def open_device(self, dev) -> None: ...
    def close_device(self, dev_handle) -> None: ...
    def set_configuration(self, dev_handle, config_value) -> None: ...
    def get_configuration(self, dev_handle) -> None: ...
    def set_interface_altsetting(self, dev_handle, intf, altsetting) -> None: ...
    def claim_interface(self, dev_handle, intf) -> None: ...
    def release_interface(self, dev_handle, intf) -> None: ...
    def bulk_write(self, dev_handle, ep, intf, data, timeout) -> None: ...
    def bulk_read(self, dev_handle, ep, intf, buff, timeout) -> None: ...
    def intr_write(self, dev_handle, ep, intf, data, timeout) -> None: ...
    def intr_read(self, dev_handle, ep, intf, size, timeout) -> None: ...
    def iso_write(self, dev_handle, ep, intf, data, timeout) -> None: ...
    def iso_read(self, dev_handle, ep, intf, size, timeout) -> None: ...
    def ctrl_transfer(
        self, dev_handle, bmRequestType, bRequest, wValue, wIndex, data, timeout
    ) -> None: ...
    def clear_halt(self, dev_handle, ep) -> None: ...
    def reset_device(self, dev_handle) -> None: ...
    def is_kernel_driver_active(self, dev_handle, intf) -> None: ...
    def detach_kernel_driver(self, dev_handle, intf) -> None: ...
    def attach_kernel_driver(self, dev_handle, intf) -> None: ...

# Names in __all__ with no definition:
#   libusb0
#   libusb1
#   openusb
